      SUBROUTINE blkdta
************************************************************************
*                                                                      *
*     Subroutine BLKDTA set up defaults for the simulation             *
*     parameters.                                                      *
*                                                                      *
*                                                                      *
*                                                                      *
*                                                                      *
*                                                                      *
*                                                                      *
*                                                                      *
************************************************************************

      use unit
      use parst
      use cpropar
      use meta
      use rem
      use sge, only: sge_update, sge_update_rst, sge_update_fly,
     &     nstep_fly, lfirst_sge, sge_tsave_work, sge_tsave_pmf,
     &     sim_tempering, sge_ts, sim_tempering_sge, sge_print_wham,
     &     sge_print, sge_f, sge_transition_scheme
      use dcd, only: kdcd,ndcd,dcd_frame,dcd_noh

      IMPLICIT none

      INTEGER i,j

      COMMON /card / jrec,nrec,jerr,nerr,nline,istrt
      INTEGER jrec,nrec,jerr,nerr,nline,istrt(80)
      integer iproc
      CHARACTER*80 fileout
#ifdef PARALLEL
      include 'mpif.h'
      integer ierr
      CALL mpi_comm_rank(mpi_comm_world, iproc, ierr)
#else
      iproc = 0
#endif


*=======================================================================
*------- Set defaults parameters ---------------------------------------
*=======================================================================

#ifdef PARALLEL
      WRITE (fileout,'(a,i4.4)') TRIM("out"),iproc
      kprint=85
      open(unit=kprint,file=fileout,form='FORMATTED',status='UNKNOWN')
      knlist=86
      open(unit=knlist,file='INPUT',form='FORMATTED',status
     &     ='UNKNOWN')
#else
      knlist=5
      kprint=6
#endif
! with SAVE_ALL_RESTARTS, kdump is not incremented by openf.f
! first used value kdump=0 will result in an error in AIX 6.1 (UNIT=0 is stderr)
!      kdump=0
      kdump=10
      kgdata=0
      kcnfig=0
      kgofr=0
      kplot=0
      kconf=0
      kpot=0
      kout=0
      kfield=0
      kvaf=0
      krms=0
      kxrms=0
      kxrms_atm=0
      ksol1=0
      ksol2=0
      kgroup=0
      ktop=0
      ktemplate=0
      ktest=0
      iurest=0
      kspec=0
      kgr=0
      kplot_fragm=0
      kplot_center=0
      kplot_steer = 0
      kplot_stn0=0
      kgofr_sk=0
      kcoord_slt=0
      kcoord_slv=0
      ktpgprm_read=0
      ktpgprm_write=0
      kfreq=0
      annpro=0
      jerr=1
      frequencies=.FALSE.
      debug=.FALSE.
      debug_rs=.FALSE.
      debug_ct=.FALSE.
      debug_st=.FALSE.
      debug_bt=.FALSE.
      debug_pt=.FALSE.
      debug_it=.FALSE.
      energy_then_die=.FALSE.
      cutoff=.TRUE.
      grpcut=.FALSE.
      protei=.FALSE.
      solven=.FALSE.
      electr=.FALSE.
      clewld=.FALSE.
      linser=.FALSE.
      recstrc=.FALSE.
      stinit = .FALSE.
      tpgfil = .FALSE.
      rescm  = .FALSE.
      tpgwbn = .FALSE.
      prttpg = .FALSE.
      sction=.FALSE.
      prtatl=.FALSE.
      prthbl=.FALSE.
      prtnbl=.FALSE.
      prtn14=.FALSE.
      prtcnl=.FALSE.
      prtbal=.FALSE.
      prtptl=.FALSE.
      prtitl=.FALSE.
      prtipw=.FALSE.
      hmass=.FALSE.
      prttor=.FALSE.
      prtben=.FALSE.
      prtstr=.FALSE.
      path_steer=.FALSE.
      igr=.FALSE.
      gofr=.FALSE.
      restart_cont=.FALSE.
      read_co=.FALSE.
      gofr_nprint=0
      gofr_navg=0
      gofr_ncomp=0
      gofr_neighbor=.TRUE.
      gofr_intra=.FALSE.
      gofr_avg=.FALSE.
      gofr_cut=0.0D0
      delrg=0.05D0
      lenerg=.FALSE.
      uenerg=.FALSE.
      fold=.FALSE.
      wrtgyr=.FALSE.
      noneq=.FALSE.
      lfield=.FALSE.
      print_unformatted=.FALSE.
      scharge=.FALSE.
      nonbnd=.TRUE.
      hoover=.FALSE.
      thermos=.FALSE.
      vacf=.FALSE.
      mdsim=.TRUE.
      minimize=.FALSE.
      write_grad=.FALSE.
      annealing=.FALSE.
      change_cell=.FALSE.
      analys=.FALSE.
      anxrms=.FALSE.
      anxrms_cell=.FALSE.
      ascii_nocell=.FALSE.
      anxca=.FALSE.
      anxbc=.FALSE.
      anxhe=.FALSE.
      anrms=.FALSE.
      anslv=.FALSE.
      stretch=.FALSE.
      stretch_heavy=.FALSE.
      stoprun=.FALSE.
      md_respa=.FALSE.
      adihed=.TRUE.
      hydbnd=.FALSE.
      spectra=.FALSE.
      lgr=.FALSE.
      linked_cell=.FALSE.
      agbnp=.false.
      restart_cont=.FALSE.
      adjust_cnstr=.TRUE.
      slv_read=.FALSE.
      slv_exist=.FALSE.
      slt_exist=.FALSE.
      slv_generate=.FALSE.
      slv_create=.FALSE.
      pdb_read=.FALSE.
      slt_create=.FALSE.
      abmd=.FALSE.
      dissociate=.FALSE.
      associate=.FALSE.
      diss_mol=.FALSE.
      diss_atoms=.FALSE.
      abmd_tors=.FALSE.
      occupy_space=.FALSE.
      diffusion=.FALSE.
      time_corr=.FALSE.
      not_time_corr=.FALSE.
      erf_corr=.FALSE.
      erfc_spline=.FALSE.
      remove_momentum=.FALSE.
      always_scale_nose=.FALSE.
      anprot=.FALSE.
      divide_records=1
      divide_spline=1
      ns1=256
      nv1=256
      ns2=512
      nv2=512
      ns3=1024
      nv3=1024
      ns4=2048
      nv4=2048
      niop=1
      nios=1
      rpass =0.005
      ngprint = 10000
      nprot_charges=0
      corr_atoms(1)=0
      do i=1,5
         ntmtsp(i)=-1
      end do
      do i=1,3
         ntmtss(i)=-1
      end do


      totvaf=300
      novaf=3
      pext=0.0D0
      taut=0.0D0
      taup=0.0D0
      compressibility=5.3D-04
      isostress=.FALSE.
      cpress=.FALSE.
      pressure=.FALSE.
      lberendsen=.FALSE.
      landersen=.FALSE.
      coupl_mol=.TRUE.
      coupl_grp=.FALSE.
      coupl_atm=.FALSE.
      wpr=1.0D19
      massinfty=1.0D20
      ecut=1.0D0
      epcut=1.0D0
      echrg=-11.0D0
      pec=8
      nec=100
      rspcut=1.0D0
      rspoff=0.0D0
      rspon=1.0D0
      hrcut=1.0D0
      hacut=10.0D0
      hrson=3.50D0
      hrsoff=4.50D0
      hanon=50.0D0
      hanoff=70.0D0
      rcut_hb=4.5D0
      acut_hb=0.0D0
      a2cut_hb=0.0D0
      nhskip=3
      nupdte=20
      nupdte_index=1
      alphal=0.4D0
      omega=1.0D0
      spring=0.0D0
      lmbdt=0.5D0
      rgnato=0
      fudge=1.0D0
      lj_fudge=1.0D0
      ancorr=100
      antstar=0.0D0
      anfact=1.0D0
      dtemph=5000.0D0
      dtemppr=10000.0d0 
      hstep_freq=0.03D0
      nstep_freq=6
      neta=3
      DO i=1,neta
         qmass(i)=0.0D0
      END DO
      scale=1E8
      iseed=12345667
      compressibility=4.9D-04
      eps_energy=0.5D0
      itor_ptype=0
      nospt=3
      nplot_fragm=0
      nplot_center=0
      ncofactor=0
      nfragm=0
      nrespa=1
      n0respa=1
      n1respa=1
      mrespa=1
      lrespa=1
      ltest_times=.false.
      clean=.true.
      start_conf= .false.
      distmax = 0.25
      rcuth=9.7
      rtolh=0.3
      rcutl=7.3
      rtoll=0.3
      rcutm=4.1
      rtolm=0.3
      rneih=1.5 
      rneil=0.45
      rneim=0.35
      kl=0.0
      klt=0.0
      km=0.0
      kmt=0.0
      erfc_bin=0.007D0
      pme=.false.
      shell_pme='0'
      nfft1=0
      nfft2=0
      nfft3=0
      ntimes=0
      mim_lim=4
      pme_order=0
      DO 10 i=1,8
          DO 20 j=1,3
              rmol(j,i)=0.0D0
20        CONTINUE
10    CONTINUE
      mixrww=.true.
      mixrwp=.false.
      amphi=.FALSE.
      bending=.TRUE.
      replicate=.FALSE.
      write_ff_pars=.FALSE.
      nplot=0
      nascii=0
      nfield=0
      mfield=1
      nvi = 0
      ndipole = 0
      nhoov=1
      whoov=500.0D0
      time=1.0D0
      radius=1.6d+0
      rkcut=1.0D9
      rcut_corr = 0.0d0 
      nflag(1)=0
      nflag(2)=0
      maxstp=1
      maxrun=0
      nrject=1
      nprop=200
      nsave=0
      nconf=0
      nprint=1
      menerg=0
      t=300.0D0
      baxis=0.0D0
      caxis=0.0D0
      nform=1
      icl=1
      icm=1
      icn=1
      nmol=0
      nato_slv=0
      start_anl=1
      stop_anl=2**(24)
      update_anl=0
      cutoff_vor=6.0D0
      voronoi_res(1)=-1
      voronoi_access=.FALSE.
      voronoi_volume=.FALSE.
      voronoi_neighbor=.FALSE.
      hbonds_res=.FALSE.
      hbonds_tot=.FALSE.
      hbonds_vor=.FALSE.
      prttopl=.FALSE.
      fragm_dist=.FALSE.
! Statements for REM
      rem_run = .false.
      rem_acc=0
      rep_acc=0
      rem_ts=0.d0
      rem_print=0.d0
      rem_segment = .false.
      prnt_remdt = .false.
      nrem = 0
! Statements for SGE
      sge_ts = 0.d0
      sge_f = 0.d0
      sge_update = 0
      sge_update_rst = 0
      sge_update_fly = 0
      nstep_fly = 0
      sge_tsave_work = 0.d0
      sge_tsave_pmf = 0.d0
      sge_print = 0.d0
      sim_tempering = .false.
      sim_tempering_sge = .false.
      lfirst_sge = .true.
      sge_print_wham = .false.
      sge_transition_scheme = 'DEO'
! Statements for metadynamics
      kmeta = 0
      meta_run = .FALSE.
      meta_tempered = .FALSE.
      meta_wtempered = .FALSE.
      metar = .FALSE.
      metaw = .FALSE.
      meta_analysis = .FALSE.
      meta_ts = 0.d0
      meta_height = 0.d0
      meta_nrc = 0
      meta_print = 0.d0
      meta_n = 0
      meta_step = 0
      meta_tot = 0.d0
      meta_maxv = 0.d0
      meta_temperature = 0.d0
! statements for dcd
      kdcd = 0
      krem_dcd = 0
      ndcd = 0
      dcd_frame = 0
      dcd_noh = .false.

*================= END OF EXECUTABLE STATEMENTS ========================

      RETURN
      END

