      SUBROUTINE read_potential(fupdte,fabmd,err_args,err_unr,err_end)

************************************************************************
*                                                                      *
*                                                                      *
*                                                                      *
*======================================================================*
*                                                                      *
*              Author:  Piero Procacci                                 *
*              Dip. Chimica,  Firenze                                  *
*                                                                      *
*                                                                      *
*                                                                      *
************************************************************************


*======================== DECLARATIONS ================================*

      use unit
      use parst
      use cpropar

      IMPLICIT none

*----------------------------- ARGUMENTS ------------------------------*
      
      INTEGER iret
      REAL*8  fupdte,fabmd
      CHARACTER*37 err_args(2)
      CHARACTER*20 err_end 
      CHARACTER*27 err_unr(4)

*------------------------- LOCAL VARIABLES ----------------------------*

      INTEGER nword,nsevere,nwarning,j,kaux,i
      CHARACTER*80 errmsg
      CHARACTER*80 line,strngs(40),filepath
      CHARACTER*8 fmt
      CHARACTER*1 sep(2),comm(2)
      CHARACTER*10 chari
      LOGICAL  exist
      DATA sep/' ',','/comm/'(',')'/
      REAL*8 aux

*----------------------- EXECUTABLE STATEMENTS ------------------------*


c=======================================================================
c     Environment parser starts here 
c=======================================================================

      j=0
      nbonds_added = 0
      nbends_added = 0
      nitors_added = 0
      nbonds_steer_added = 0
      nbends_steer_added = 0
      nitors_steer_added = 0
      nsevere = 0 
      nwarning = 0 
      line(79:80)='  '
100   READ(knlist,'(a78)',END=600) line(1:78)
      CALL wrenc(kprint,line)
      IF(line(1:1) .EQ. '#') GOTO 100 
      CALL parse(line,sep,2,comm,strngs,40,nword,iret,errmsg)
      IF(iret.EQ.1) THEN 
         errmsg='while parsing line: toomany strings'
         CALL xerror(errmsg,80,1,2)
         nsevere = nsevere + 1
         go to 100
      END IF

c==== Command GROUP_CUTOFF=============================================

      IF(strngs(1).EQ. 'GROUP_CUTOFF' ) THEN
         if(nword.eq.2.or.nword.eq.4) THEN 
            IF(strngs(2).EQ. 'ON' ) THEN
               grpcut=.TRUE.
               IF(nword .EQ. 4) THEN
                  IF(strngs(3) .EQ. 'CUTSPH') THEN
                     CALL fndfmt(2,strngs(4),fmt)
                     READ(strngs(4),fmt,err=20) rspon
                  END IF
               ELSE
                  nwarning = nwarning  + 1
                  errmsg='Unrecognized or missing keyword '// 
     &                 '; RSPON set to 1.0' 
                  CALL xerror(errmsg,80,1,11)
                  rspon=1.0D0
               END IF
            ELSE IF(strngs(2).EQ. 'OFF' ) THEN
               grpcut=.FALSE.
            ELSE
               nsevere = nsevere + 1
               errmsg=err_unr(3)//strngs(2) 
               CALL xerror(errmsg,80,1,30)
            END IF
         ELSE
            nsevere = nsevere + 1
            errmsg=err_args(1) //'1'
            CALL xerror(errmsg,80,1,30)
         END IF

c==== Command EWALD====================================================

      ELSE IF(strngs(1).EQ. 'EWALD' ) THEN
         IF(nword .EQ. 1) THEN
            nsevere = nsevere + 1
            errmsg=err_args(1) //'1'
            CALL xerror(errmsg,80,1,30)
         ELSE
            IF(strngs(2).EQ. 'ON' ) THEN
               clewld=.TRUE.
               IF(nword .EQ. 4) THEN
                  CALL fndfmt(2,strngs(3),fmt)
                  READ(strngs(3),fmt,err=20) alphal
                  CALL fndfmt(2,strngs(4),fmt)
                  READ(strngs(4),fmt,err=20) rkcut
               ELSE IF(nword .EQ. 3) THEN
                  CALL fndfmt(2,strngs(3),fmt)
                  READ(strngs(3),fmt,err=20) alphal
               ELSE
                  nsevere = nsevere + 1
                  errmsg=err_args(1) // '1 after keyword "on"'
                  CALL xerror(errmsg,80,1,30)
               END IF
               
            ELSE IF(strngs(2).EQ. 'PME' ) THEN
               clewld=.true.
               pme=.true.
               IF(nword .EQ. 7) THEN
                  CALL fndfmt(2,strngs(3),fmt)
                  READ(strngs(3),fmt,err=20) alphal
                  CALL fndfmt(1,strngs(4),fmt)
                  READ(strngs(4),fmt,err=20) nfft1
                  CALL fndfmt(1,strngs(5),fmt)
                  READ(strngs(5),fmt,err=20) nfft2
                  CALL fndfmt(1,strngs(6),fmt)
                  READ(strngs(6),fmt,err=20) nfft3
                  CALL fndfmt(1,strngs(7),fmt)
                  READ(strngs(7),fmt,err=20) pme_order
               ELSE
                  nsevere = nsevere + 1
                  errmsg=err_args(1) // '4 after keyword "PME"' 
                  CALL xerror(errmsg,80,1,30)
               END IF
            ELSE IF(strngs(2) .EQ. 'REMOVE_MOMENTUM') THEN
               remove_momentum=.TRUE.
   
            ELSE IF(strngs(2).EQ. 'OFF' ) THEN
               clewld=.FALSE.
               
            ELSE
               nsevere = nsevere + 1
               errmsg=err_unr(3) // strngs(2) 
               CALL xerror(errmsg,80,1,30)
            END IF
         END IF

c==== Command ERFC_SPLINE==============================================

      ELSE IF(strngs(1).EQ. 'ERFC_SPLINE' ) THEN
         erfc_spline=.TRUE.
         erfc_spline_corr=.false.
         IF(nword .NE. 1) THEN
            CALL fndfmt(2,strngs(2),fmt)
            READ(strngs(2),fmt,err=20) erfc_bin
            IF(nword.NE.2) THEN 
              if(strngs(3).eq.'corrected') erfc_spline_corr=.true.
              if(nword.NE.3) THEN 
                CALL fndfmt(2,strngs(4),fmt)
                READ(strngs(4),fmt,err=20) rcut_corr
              END IF
            END IF
         END IF
         
c==== Command ERF_CORR=================================================

      ELSE IF(strngs(1).EQ. 'ERF_CORR' ) THEN
         erf_corr=.TRUE.
         IF(nword .EQ. 4) THEN
            CALL fndfmt(1,strngs(2),fmt)
            READ(strngs(2),fmt,err=20) nbinew
            CALL fndfmt(2,strngs(3),fmt)
            READ(strngs(3),fmt,err=20) rlew
            CALL fndfmt(2,strngs(4),fmt)
            READ(strngs(4),fmt,err=20) ruew
            delew = (ruew-rlew)/DFLOAT(nbinew) 
          ELSE
            nsevere = nsevere + 1
            errmsg=err_args(1) // '3 after keyword "ERF_CORR"' 
            CALL xerror(errmsg,80,1,30)
         ENDIF

c==== Command CUTOFF===================================================

      ELSE IF(strngs(1).EQ. 'CUTOFF' ) THEN
         IF(nword.ne.1) THEN 
            CALL fndfmt(2,strngs(2),fmt)
            READ(strngs(2),fmt,err=20) rspoff
         END IF
         
c==== Command LINKED CELL =============================================

      ELSE IF(strngs(1).EQ. 'LINKED_CELL' ) THEN
         LINKED_CELL = .TRUE.            
         IF(nword.EQ.4) THEN 
            CALL fndfmt(1,strngs(2),fmt)
            READ(strngs(2),fmt,err=20) ncx
            CALL fndfmt(1,strngs(3),fmt)
            READ(strngs(3),fmt,err=20) ncy
            CALL fndfmt(1,strngs(4),fmt)
            READ(strngs(4),fmt,err=20) ncz
         ELSE IF(nword .EQ. 5) THEN
            CALL fndfmt(1,strngs(2),fmt)
            READ(strngs(2),fmt,err=20) ncx
            CALL fndfmt(1,strngs(3),fmt)
            READ(strngs(3),fmt,err=20) ncy
            CALL fndfmt(1,strngs(4),fmt)
            READ(strngs(4),fmt,err=20) ncz
            CALL fndfmt(1,strngs(5),fmt)
            READ(strngs(5),fmt,err=20) nupdte_index
         ELSE
            nsevere = nsevere + 1
            errmsg=err_args(1) //'3'
            CALL xerror(errmsg,80,1,30)
         ENDIF

c==== Command VERLET_LIST==============================================

      ELSE IF(strngs(1).EQ. 'VERLET_LIST' ) THEN
         LINKED_CELL = .FALSE.            

c==== Command AGBNP ===================================================

      ELSE IF(strngs(1).EQ. 'AGBNP' ) THEN
         agbnp = .true.            

c==== Command UPDATE===================================================

      ELSE IF(strngs(1).EQ. 'UPDATE' ) THEN
         IF(nword .EQ. 3) THEN
            CALL fndfmt(2,strngs(2),fmt)
            READ(strngs(2),fmt,err=20) fupdte
            CALL fndfmt(2,strngs(3),fmt)
            READ(strngs(3),fmt,err=20) rspcut
         ELSE IF(nword .EQ. 5) THEN
            CALL fndfmt(2,strngs(4),fmt)
            READ(strngs(4),fmt,err=20) hrcut
            CALL fndfmt(2,strngs(5),fmt)
            READ(strngs(5),fmt,err=20) hacut
         ELSE
            nsevere = nsevere + 1
            errmsg=err_args(1) //'4'
            CALL xerror(errmsg,80,1,30)
         END IF

c==== Command  HBOND =================================================

      ELSEIF(strngs(1).EQ. 'H-BOND' ) THEN
         IF(strngs(2).EQ. 'ON' ) THEN
            hydbnd=.TRUE.
            CALL fndfmt(2,strngs(3),fmt)
            READ(strngs(3),fmt,err=20) hrson
            CALL fndfmt(2,strngs(4),fmt)
            READ(strngs(4),fmt,err=20) hrsoff
            CALL fndfmt(2,strngs(5),fmt)
            READ(strngs(5),fmt,err=20) hanon
            CALL fndfmt(2,strngs(6),fmt)
            READ(strngs(6),fmt,err=20) hanoff
            CALL fndfmt(1,strngs(7),fmt)
            READ(strngs(7),fmt,err=20) nhskip
         ELSE IF(strngs(2).EQ. 'OFF' ) THEN
            hydbnd=.FALSE.
         ELSE
            errmsg=err_unr(3) // strngs(2) 
            CALL xerror(errmsg,80,1,30)
            nsevere = nsevere + 1
         END IF

c==== Command  I-TORSION==============================================

      ELSE IF(strngs(1).EQ. 'I-TORSION' ) THEN
         IF( nword .NE. 2) THEN
            errmsg=err_args(1)//'1'
            CALL xerror(errmsg,80,1,30)
            nsevere = nsevere + 1
         ELSE
            IF(strngs(2) .EQ. 'HARMONIC' ) THEN
               itor_ptype=1
            ELSE IF(strngs(2) .EQ. 'COSINE' ) THEN
               itor_ptype=2
            ELSE
               errmsg=err_unr(3) // strngs(2)
               CALL xerror(errmsg,80,1,30)
               nsevere = nsevere + 1
            END IF
         END IF
         
c==== Command  H-MASS=================================================

      ELSE IF(strngs(1).EQ. 'H-MASS' ) THEN
         hmass=.TRUE.
         CALL fndfmt(2,strngs(2),fmt)
         READ(strngs(2),fmt,err=20) hdmass
         
c==== Command  QQ-FUDGE===============================================
         
      ELSE IF(strngs(1) .EQ. 'QQ-FUDGE') THEN
         if(nword.eq.2) THEN 
            CALL fndfmt(2,strngs(2),fmt)
            READ(strngs(2),fmt,err=20) fudge
         ELSE
            errmsg=err_args(1)//'1'
            CALL xerror(errmsg,80,1,30)
            nsevere = nsevere + 1
         END IF
         
c==== Command  LJ-FUDGE===============================================

      ELSE IF(strngs(1) .EQ. 'LJ-FUDGE') THEN
         if(nword.eq.2) THEN 
            CALL fndfmt(2,strngs(2),fmt)
            READ(strngs(2),fmt,err=20) lj_fudge
            lj_fudgeb=lj_fudge
         ELSE
            errmsg=err_args(1)//'1'
            CALL xerror(errmsg,80,1,30)
            nsevere = nsevere + 1
         END IF
         
c==== Command  BENDING================================================

      ELSE IF(strngs(1) .EQ. 'BENDING') THEN 
         if(nword.eq.2) THEN 
            IF(strngs(2) .EQ. 'OFF') THEN
               bending=.FALSE.
            ELSE IF(strngs(2) .EQ. 'ON') THEN
               bending=.TRUE.
            ELSE 
               errmsg=err_unr(3)//strngs(2)
               CALL xerror(errmsg,80,1,30)
               nsevere = nsevere + 1
            END IF
         ELSE
            errmsg=err_args(1)//'1'
            CALL xerror(errmsg,80,1,30)
            nsevere = nsevere + 1
         END IF
            
c==== Command  AUTO_DIHEDRAL==========================================

      ELSE IF(strngs(1).EQ. 'AUTO_DIHEDRAL' ) THEN
         adihed = .TRUE.
         
c==== Command  SELECT_DIHEDRAL========================================

      ELSE IF(strngs(1).EQ. 'SELECT_DIHEDRAL' ) THEN
         adihed = .FALSE.
         
c==== Command  SELECT_STRETCHING======================================

      ELSE IF(strngs(1).EQ. 'STRETCHING' ) THEN
         stretch = .TRUE.
         IF(nword.gt.1) THEN 
            IF(strngs(2) .EQ. 'HEAVY') THEN
               stretch_heavy= .TRUE.
            ELSE 
               errmsg=err_unr(3)//strngs(2)
               CALL xerror(errmsg,80,1,30)
               nsevere = nsevere + 1
            END IF
         END IF

c==== Command  COMMAND NONBONDED_OFF==================================

      ELSE IF(strngs(1).EQ. 'NONBONDED_OFF' ) THEN
         nonbnd=.FALSE.
         
c==== Command  CONSTRAINT  ===========================================

      ELSE IF(strngs(1).EQ. 'CONSTRAINT') THEN
         IF(nword .GT. 1) THEN 
            IF(strngs(2) .EQ. 'SHAKE') THEN
               mim_lim=0
            ELSE IF(strngs(2) .EQ. 'MIM') THEN
               IF(nword .EQ. 3) THEN
                  CALL fndfmt(1,strngs(3),fmt)
                  READ(strngs(3),fmt,err=20) mim_lim
               ELSE
                  mim_lim=20
               END IF
            ELSE
               nsevere = nsevere + 1
               errmsg=err_unr(3)//strngs(2) 
               CALL xerror(errmsg,80,1,30)
            END IF
         ELSE
            nsevere = nsevere + 1
            errmsg=err_args(1) //'1'
            CALL xerror(errmsg,80,1,30)
         END IF

c==== Command  KEEP_BONDS =============================================

      ELSE IF(strngs(1).EQ. 'KEEP_BONDS' ) THEN
         adjust_cnstr = .FALSE.

c==== Command  ADD_BONDS ========================================

      ELSE IF(strngs(1).EQ. 'ADD_STR_BONDS' ) THEN
         nbonds_added = nbonds_added+1
         strbonds(nbonds_added)=.false.
         if(path_steer) THEN
           errmsg = 'cannot define extra steer coord *after* STEER_PATH'
           CALL xerror(errmsg,80,1,30)
           nsevere = nsevere + 1
         END IF
         if(nbonds_added.ge.500) THEN 
           errmsg =
     &          ' toomany ADD_STR_BONDS directives:'
     &          // ' Max is 500'
           CALL xerror(errmsg,80,1,30)
           STOP
         END IF
         if(nword.eq.5.or.nword.eq.6) THEN  
           CALL fndfmt(1,strngs(2),fmt)
           READ(strngs(2),fmt,err=20) atom_b1(nbonds_added)
           CALL fndfmt(1,strngs(3),fmt)
           READ(strngs(3),fmt,err=20) atom_b2(nbonds_added)
           if(atom_b1(nbonds_added).eq.atom_b2(nbonds_added)) THEN 
             errmsg = ' atom 1 must be not equal to atom 2 ' 
             CALL xerror(errmsg,80,1,30)
             nsevere = nsevere + 1
           END IF
           CALL fndfmt(2,strngs(4),fmt)
           READ(strngs(4),fmt,err=20) force_cost(nbonds_added)
           CALL fndfmt(2,strngs(5),fmt)
           READ(strngs(5),fmt,err=20) eqdist(nbonds_added)
           IF(nword.eq.6) THEN 
             CALL fndfmt(2,strngs(6),fmt)
             READ(strngs(6),fmt,err=20) eqdist1(nbonds_added)
             aux = abs(eqdist1(nbonds_added)-eqdist(nbonds_added))
             if(aux.gt.0.001D0) strbonds(nbonds_added) = .TRUE.
             nbonds_steer_added=nbonds_steer_added+1
           END IF
         ELSE
           nsevere = nsevere + 1
           errmsg=err_args(1) // '5 or 6'
           CALL xerror(errmsg,80,1,30)
         END  IF

c==== Command  ADD_BENDINGS ===========================================

      ELSE IF(strngs(1).EQ. 'ADD_STR_BENDS' ) THEN
         nbends_added = nbends_added+1
         strbends(nbends_added)=.false.
         if(path_steer) THEN
           errmsg = 'cannot define extra steer coord *after* STEER_PATH'
           CALL xerror(errmsg,80,1,30)
           nsevere = nsevere + 1
         END IF
         if(nbends_added.ge.500) THEN 
           errmsg =
     &          ' toomany ADD_STR_BENDS directives:'
     &          // ' Max is 500'
           CALL xerror(errmsg,80,1,30)
           STOP
         END IF
         if(nword.eq.6.or.nword.eq.7) THEN  
           CALL fndfmt(1,strngs(2),fmt)
           READ(strngs(2),fmt,err=20) atom_be1(nbends_added)
           CALL fndfmt(1,strngs(3),fmt)
           READ(strngs(3),fmt,err=20) atom_be2(nbends_added)
           CALL fndfmt(1,strngs(4),fmt)
           READ(strngs(4),fmt,err=20) atom_be3(nbends_added)

           if(atom_be1(nbends_added).eq.atom_be2(nbends_added).or. 
     &        atom_be2(nbends_added).eq.atom_be3(nbends_added).or. 
     &        atom_be1(nbends_added).eq.atom_be3(nbends_added))
     &     THEN 
             errmsg = ' atom labels must be different '
             CALL xerror(errmsg,80,1,30)
             nsevere = nsevere + 1
           END IF
           CALL fndfmt(2,strngs(5),fmt)
           READ(strngs(5),fmt,err=20) force_ang(nbends_added)
           CALL fndfmt(2,strngs(6),fmt)
           READ(strngs(6),fmt,err=20) eqang(nbends_added)
           IF(nword.eq.7)THEN 
             CALL fndfmt(2,strngs(7),fmt)
             READ(strngs(7),fmt,err=20) eqang1(nbends_added)
             aux = abs(eqang1(nbends_added)-eqang(nbends_added))
             if(aux.gt.0.001D0) strbends(nbends_added) = .TRUE.
             nbends_steer_added=nbends_steer_added+1
           END IF
         ELSE
           nsevere = nsevere + 1
           errmsg=err_args(1) //'6 or 7'
           CALL xerror(errmsg,80,1,30)
         END  IF

c==== Command  ADD_TORSION ===========================================

      ELSE IF(strngs(1).EQ. 'ADD_STR_TORS' ) THEN
         nitors_added = nitors_added+1
         strtors(nitors_added)=.false.
         if(path_steer) THEN
           errmsg = 'cannot define extra steer coord *after* STEER_PATH'
           CALL xerror(errmsg,80,1,30)
           nsevere = nsevere + 1
         END IF
           
         if(nitors_added.ge.500) THEN 
           errmsg =
     &          ' toomany ADD_STR_TORS directives:'
     &          // ' Max is 500'
           CALL xerror(errmsg,80,1,30)
           STOP
         END IF
         if(nword.eq.7.or.nword.eq.8) THEN  
           CALL fndfmt(1,strngs(2),fmt)
           READ(strngs(2),fmt,err=20) atom_it1(nitors_added)
           CALL fndfmt(1,strngs(3),fmt)
           READ(strngs(3),fmt,err=20) atom_it2(nitors_added)
           CALL fndfmt(1,strngs(4),fmt)
           READ(strngs(4),fmt,err=20) atom_it3(nitors_added)
           CALL fndfmt(1,strngs(5),fmt)
           READ(strngs(5),fmt,err=20) atom_it4(nitors_added)

           if(atom_it1(nitors_added).eq.atom_it2(nitors_added).or. 
     &        atom_it1(nitors_added).eq.atom_it3(nitors_added).or. 
     &        atom_it1(nitors_added).eq.atom_it4(nitors_added).or. 
     &        atom_it2(nitors_added).eq.atom_it3(nitors_added).or. 
     &        atom_it2(nitors_added).eq.atom_it4(nitors_added).or. 
     &        atom_it3(nitors_added).eq.atom_it4(nitors_added))
     &     THEN 
             errmsg = ' atom labels must be different '
             CALL xerror(errmsg,80,1,30)
             nsevere = nsevere + 1
           END IF
           CALL fndfmt(2,strngs(6),fmt)
           READ(strngs(6),fmt,err=20) force_died(nitors_added)
           CALL fndfmt(2,strngs(7),fmt)
           READ(strngs(7),fmt,err=20) eqdied(nitors_added)
           if(eqdied(nitors_added).lt.-180.d0) THEN 
             errmsg = ' init diehdral angle cannot be  lt -180 deg. '
             CALL xerror(errmsg,80,1,30)
             nsevere = nsevere + 1
           END IF
           if(nword.eq.8) THEN 
             CALL fndfmt(2,strngs(8),fmt)
             READ(strngs(8),fmt,err=20) eqdied1(nitors_added)
             if(eqdied1(nitors_added).gt.360.d0) THEN 
               errmsg = ' final diehdral angle cannot be gt 360 deg. '
               CALL xerror(errmsg,80,1,30)
               nsevere = nsevere + 1
             END IF
             aux = abs(eqdied1(nitors_added)-eqdied(nitors_added))
             if(aux.gt.0.001D0) strtors(nitors_added) = .TRUE.
             nitors_steer_added=nitors_steer_added+1
           END IF
         ELSE
           nsevere = nsevere + 1
           errmsg=err_args(1) //'8'
           CALL xerror(errmsg,80,1,30)
         END  IF

c==== Command  STEER_PATH  ==========================================

       ELSE IF(strngs(1).EQ. 'STEER_PATH' ) THEN
         path_steer=.true.
         IF(  nbonds_steer_added.EQ.0.and.
     &        nbends_steer_added.EQ.0.and.
     &        nitors_steer_added.EQ.0) THEN
           errmsg='No steering coordinates defined.'/
     &          /' Define them *before* STEER_PATH'  
           CALL xerror(errmsg,80,1,30)
           nsevere=nsevere+1
         END IF
         if(nbonds_steer_added.gt.5) THEN
           errmsg='More than 5 bonds steer defined' 
           CALL xerror(errmsg,80,1,30)
           nsevere=nsevere+1
         end if  
         if(nbends_steer_added.gt.5) THEN
           errmsg='More than 5 bends steer defined' 
           CALL xerror(errmsg,80,1,30)
           nsevere=nsevere+1
         end if  
         if(nitors_steer_added.gt.5) THEN
           errmsg='More than 5 tors steer defined' 
           CALL xerror(errmsg,80,1,30)
           nsevere=nsevere+1
         end if  
         IF(strngs(2) .EQ. 'OPEN') THEN
           CALL uscrpl(strngs(4),80)
           filepath=strngs(3)
           INQUIRE(FILE=filepath,EXIST=exist)
           IF(.NOT. exist) THEN
             errmsg=
     &         'Path File '//TRIM(filepath)//' does not exist. Abort.'
             CALL xerror(errmsg,80,1,30)
             nsevere=nsevere+1
           ELSE
             CALL openf(kaux,strngs(3),'FORMATTED','OLD',0)
             do i=1,5000
               read(kaux,*,end=1008,ERR=1007)  timerec(i),
     &              (pathbo(i,j),j=1,nbonds_steer_added),
     &              (pathbe(i,j),j=1,nbends_steer_added),
     &              (pathto(i,j),j=1,nitors_steer_added)
               timerec(i)=timerec(i)*1000.d0
             end do
             write(chari,'(f10.2)') timerec(5000) 
             errmsg='Path file too long; Last timeslice read in '//chari
             nsevere=nsevere +1 
1007         errmsg=
     &            'Something wrong in reading Path File'//TRIM(filepath)
             CALL xerror(errmsg,80,1,30)
             write(kprint,1009) nbonds_steer_added,nbends_steer_added
     &            ,nitors_steer_added
1009         format(' ===== On each line ORAC expects: time ',i4
     &            ,' bonds',i4,' bends and',i4,' tors'/
     &            ' ===== where time must be expressed in picoseconds')
             nsevere=nsevere+1
1008         ntimes=i-1
           END IF
         ELSE
           errmsg='OPEN keyword not found'
           CALL xerror(errmsg,80,1,30)
           nsevere = nsevere + 1
         END IF
        

c==== Command  ADJUST_BONDS ==========================================

      ELSE IF(strngs(1).EQ. 'ADJUST_BONDS' ) THEN
         adjust_cnstr = .TRUE.

c==== Command BLANK LINE===============================================

      ELSE IF(strngs(1).EQ. ' ') THEN

c==== Begininning of next ENVIRONMENT =================================

      ELSE IF(strngs(1)(1:1).EQ. '&'.AND.strngs(1).NE. '&END') THEN
         errmsg= err_unr(1) // strngs(1)(1:8) // err_end
         CALL xerror(errmsg,80,1,30)
         nsevere = nsevere + 1
         GO TO 600

c==== Command &END ====================================================

      ELSE IF(strngs(1).EQ. '&END') THEN
         GOTO 600
         
      ELSE
         errmsg= err_unr(1) // strngs(1)(1:8) // err_end
         CALL xerror(errmsg,80,1,30)
         nsevere = nsevere + 1
      END IF

      GO TO 100

600   CONTINUE

c=======================================================================
c     Environment parser ends here 
c=======================================================================

c--   syntax errors: abort without verifying input 
      if(nsevere.gt.0.and.nsevere.lt.99) then 
         call int_str(nsevere,fmt,j)
         errmsg=fmt(1:j) //' ERRORS WHILE EXECUTING READ_POTENTIAL'
         call xerror(errmsg,80,1,2)
         STOP
      ELSE IF(nsevere.gt.99) THEN 
         errmsg= 'MORE THAN 99 ERRORS WHILE EXECUTING READ_POTENTIAL'
         call xerror(errmsg,80,1,2)
         STOP
      END IF
      if(nwarning.gt.0.and.nwarning.lt.99) then 
         j=0
         call int_str(nwarning,fmt,j)
         errmsg= fmt(1:j)//' WARNINGS WHILE EXECUTING READ_POTENTIAL'
         CALL xerror(errmsg,80,1,1)
      ELSE IF(nwarning.gt.99) THEN 
         errmsg= 'MORE THAN 99 WARNINGS WHILE EXECUTING READ_POTENTIAL'
         call xerror(errmsg,80,1,1)
      ENDIF    

c==============================================================================
c     Verification Part
c==============================================================================

c--   Check if pme_orded is gt 3 
      if(pme.and.(pme_order.lt.3)) THEN 
         errmsg='"Ewald": PME order must be at least 3'
         CALL xerror(errmsg,80,1,30)
         nsevere = nsevere + 1
      END IF
      if(linked_cell) THEN 
         if(ncx.le.0.or.ncy.le.0.or.ncz.le.0) THEN 
            errmsg='Bad Linked Cell Neighbor list parameters'  
            CALL xerror(errmsg,80,1,30)
            nsevere = nsevere + 1
         END IF
      END IF

      if(nsevere.gt.0.and.nsevere.lt.99) then 
         j=0
         call int_str(nsevere,fmt,j)
         errmsg=fmt(1:j) //' ERRORS WHILE EXECUTING READ_POTENTIAL'
         CALL xerror(errmsg,80,1,2)
         STOP 
      ELSE IF(nsevere.gt.99) THEN
         errmsg='MORE THAN 99 ERRORS WHILE EXECUTING READ_POTENTIAL'
         call xerror(errmsg,80,1,2)
         STOP
      END IF

      RETURN

c==============================================================================
c     EOF found while reading ABMD subcommands
c==============================================================================

300   CONTINUE
      iret=1
      errmsg='EOF found while reading ABMD subcommands'
      CALL xerror(errmsg,80,1,2)
      STOP

c==============================================================================
c     Errors were found
c==============================================================================


 20   CONTINUE
      iret=1
      errmsg='internal reading error: wrong format?? TAB character??'
      CALL xerror(errmsg,80,1,2)
      STOP

*----------------- END OF EXECUTABLE STATEMENTS -----------------------*

      END
